<?php
//Fichier permettant l'export des X dernières commandes.

//Debug mode : affiche des echos des variables clés
$debug=0;
//Importation des avis produit
//global $smarty;
require_once('../../../config/config.inc.php');
require_once('../../../init.php');
require_once("functions.php");

//Fonctionnement
//SAG appelle le Client (bulkOrderInfosExport.php) en transmettant un token et le nombre de commande à exporter
//Le client (bulkOrderInfosExport.php) appelle SAG pour vérifier la validité du token
//Si le token est bon on va chercher la liste des commandes à exporter
//On envoie la liste des commandes à exporter à la fonction postData
//La fonction postData envoie les données en post en SSL avec la clé d'API

//On récupère les dates des dernières commandes à extraire
$fromDate = pSQL(Tools::getValue("fromDate"));
$toDate = pSQL(Tools::getValue("toDate"));
if (!$fromDate) {
    echo "Missing fromDate";
    exit;
}
if (!$toDate) {
    echo "Missing toDate";
    exit;
}
//On récupère le token et on vérifie que l'on ai bien le droit d'envoyer les données
$token= Tools::getValue("token");
if (!$token) {
    echo "Missing token";
    exit;
}
$checkAnswer = tokenCheck($token);
if (strpos($checkAnswer, "ValidSagData")===false) {
    if ($debug) {
        echo "$checkAnswer <br>";
        var_dump($checkAnswer);
    }
    exit;
} else {

    //Debug
    if ($debug) {
        echo "On affiche les commandes du $fromDate au $toDate<br>";
    }

    //Récupération des id states auxquels il ne faut pas envoyer le mail
    //On initialise la variable qui permettra de générer la string sql
    $exeptStatusString="";
    //On met la liste des status à exclure en array
    $exeptStatus=explode(",", Configuration::get('sag_exeptStatus'));

    if ($debug) {
        echo "Statuts à exclure: ";
    }


    //If we have states to exclude
    if (!empty($exeptStatus) and version_compare(_PS_VERSION_, '1.5', '>=')) {
        //For each field
        foreach ($exeptStatus as $value) {
            //If field is not empty and is a number
            if (!empty($value) and is_numeric($value)) {
                $value = pSQL($value);    //Clean against SQL injections
                $exeptStatusString.=" and current_state <> " . $value; //Build query
                if ($debug) {
                    echo $value .", ";
                }
            }
        }
    }

    //Récupération des infos de la commande
    $sql = "SELECT * FROM "._DB_PREFIX_."orders where `date_add` BETWEEN '$fromDate' AND '$toDate' $exeptStatusString order by `date_add` desc";
    if ($debug) {
        echo "<br>" . $sql;
    }
    if ($results0 = Db::getInstance()->ExecuteS($sql)) {
        if ($debug) {
            echo "<br>On a des commandes...";
        }

        foreach ($results0 as $row) {
            $id_order = pSQL($row['id_order']);
            $order_date = pSQL($row['date_add']);
            $id_customer = pSQL($row['id_customer']);

            //Requete pour trouver nom et prenom du client
            $sql_customer = "SELECT
            cu.firstname,
            cu.lastname,
            cu.email
            FROM
            "._DB_PREFIX_."customer as cu,
            "._DB_PREFIX_."address as ad,
            "._DB_PREFIX_."orders as od
            WHERE
            cu.id_customer=$id_customer
            AND ad.id_address=od.id_address_delivery
            AND od.id_order=$id_order";
            if ($results = Db::getInstance()->ExecuteS($sql_customer)) {
                foreach ($results as $row) {
                    $prenom = $row['firstname'];
                    $lastname = $row['lastname'];
                    $email = $row['email'];
                }
            }

            //Requete pour trouver la liste des produits commandés
            $products="";
            $sql_product = "SELECT * FROM "._DB_PREFIX_."order_detail WHERE `id_order`=$id_order";
            if ($results = Db::getInstance()->ExecuteS($sql_product)) {
                foreach ($results as $row) {
                    if (!$products) {
                        $products = $row['product_id'];
                    } else {
                        $products = $products."+".$row['product_id'];
                    }
                }
            }
            $id_site=getShopId();
            $mailToSend=array("firstname" => $prenom,
            "lastname" => $lastname,
            "id_order" => $id_order,
            "id_site" => $id_site,
            "products" => $products,
            "email" => $email);
            $toSendTable[]=$mailToSend;
        }
        if ($debug) {
            echo "<br>Var_dump de toSendTable: ";
            var_dump($toSendTable);
        }

        //On envoie les données en post avec cryptage SSL
        $posted = postData($toSendTable, "bulkOrderInfos.php", $token);
        if ($debug) {
            var_dump($posted);
        }
    } else {
        if ($debug) {
            echo "<br>Aucune commande à afficher.";
        }
    }
}
