<?php

//Debug mode : affiche des echos des variables clés
$debug=0;
//Importation des avis produit
//global $smarty;
require_once('../../../config/config.inc.php');
require_once('../../../init.php');
require_once("functions.php");

//Récupération de la clé d'api en base
$apiKey=Configuration::get('sag_apiKey');
//On récupère la clé d'API en post et on vérifie que c'est la même que celle en base
$postedApiKey = Tools::getValue('apiKey');
if ($apiKey != $postedApiKey) {
    echo "Wrong api key";
    exit;
} else {
    $afterDays=10;
    $tmpAfterDays=Configuration::get('sag_afterDays');
    if (isset($tmpAfterDays)) {
        if (is_numeric($tmpAfterDays)) {
            $afterDays=$tmpAfterDays;
        }
    }

    //Permet d'éviter de sortir les commandes auxquelles on est censé avoir déjà envoyé un mail
    $dateFrom=date("Y-m-d H:i:s", time()-($afterDays*86400 + 86400));
    $dateTo=date("Y-m-d H:i:s", time()-($afterDays*86400));

    //Debug
    if ($debug) {
        echo "On affiche les commandes du $dateFrom à $dateTo <br>";
    }

    //Récupération des id states auxquels il ne faut pas envoyer le mail
    //On initialise la variable qui permettra de générer la string sql
    $exeptStatusString="";
    //On met la liste des status à exclure en array
    $exeptStatus=explode(",", Configuration::get('sag_exeptStatus'));

    if ($debug) {
        echo "Statuts à exclure: ";
    }


    //Si on a des statuts à exclure
    if (!empty($exeptStatus) and version_compare(_PS_VERSION_, '1.5', '>=')) {
        //Pour chaque champ
        foreach ($exeptStatus as $value) {
            //On vérifie que le champ n'est pas vide et est un nombre
            if (!empty($value) and is_numeric($value)) {
                $value = pSQL($value);
                $exeptStatusString.=" AND current_state <> " . $value;
                if ($debug) {
                    echo $value;
                }
            }
        }
    }

    //Récupération des infos de la commande
    $sql = "SELECT * FROM "._DB_PREFIX_."orders WHERE `date_add` BETWEEN '$dateFrom' AND '$dateTo' $exeptStatusString";
    if ($results0 = Db::getInstance()->ExecuteS($sql)) {
        if ($debug) {
            echo "<br>On a des commandes...";
        }

        foreach ($results0 as $row) {
            $id_order = pSQL($row['id_order']);
            $order_date = pSQL($row['date_add']);
            $id_customer = pSQL($row['id_customer']);


            //Requete pour trouver nom et prenom du client
            $sql_customer = "SELECT
            cu.firstname,
            cu.lastname,
            cu.email
            FROM
            "._DB_PREFIX_."customer as cu,
            "._DB_PREFIX_."address as ad,
            "._DB_PREFIX_."orders as od
            WHERE
            cu.id_customer=$id_customer
            AND ad.id_address=od.id_address_delivery
            AND od.id_order=$id_order";
            if ($results = Db::getInstance()->ExecuteS($sql_customer)) {
                foreach ($results as $row) {
                    $prenom = $row['firstname'];
                    $lastname = $row['lastname'];
                    $email = $row['email'];
                }
            }

            //Requete pour trouver la liste des produits commandés
            $products="";
            $sql_product = "SELECT * FROM "._DB_PREFIX_."order_detail WHERE `id_order`=$id_order";
            if ($results = Db::getInstance()->ExecuteS($sql_product)) {
                foreach ($results as $row) {
                    if (!$products) {
                        $products = $row['product_id'];
                    } else {
                        $products = $products."+".$row['product_id'];
                    }
                }
            }

            $id_site=getShopId();
            $mailToSend=array("firstname" => $prenom,
                              "lastname" => $lastname,
                              "id_order" => $id_order,
                              "id_site" => $id_site,
                              "products" => $products,
                              "email" => $email);
            $toSendTable[]=$mailToSend;
        }

        echo json_encode($toSendTable);
    } else {
        if ($debug) {
            echo "<br>Aucune commande à afficher.";
        }
    }
}
