<?php
function getShopId() {
    //On récupère le shopID dans l'APIKEY
    $apiKey=Configuration::get('sag_apiKey');
    return Tools::substr($apiKey, 0, strpos($apiKey, "/"));
} 

//Fonction permettant de regénérer l'url de certificat
function setCertificateUrlFromAPI() {
    //
    //Connexion à l'API via cURL
    //
    $url_ag="https://www.societe-des-avis-garantis.fr/"; //Adresse du site Société des Avis Garantis
    $shopID=getShopId();
    $ch = curl_init();
    $timeout = 5; // set to zero for no timeout
    curl_setopt ($ch, CURLOPT_URL, $url_ag."wp-content/plugins/ag-core/api/getInfos.php?method=certificateUrl&shopID=$shopID");
    curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt ($ch, CURLOPT_CONNECTTIMEOUT, $timeout);
    $file_contents = str_replace("\xEF\xBB\xBF",'',curl_exec($ch));
    curl_close($ch);
    $urlCertificate = (string)$file_contents;
    Configuration::updateValue('sag_certificateUrl', $urlCertificate);
    return $urlCertificate;
} 

//Fonction retournant l'Url de la page du certificat (page qui montre les avis)
function getCertificateUrl() {
    //On va chercher en base l'url du certificat
    if (Configuration::get('sag_certificateUrl')) {
        return Configuration::get('sag_certificateUrl');
    } 
    //Si on ne la trouve pas en base, on demande à l'Api et on l'enregistre
    else {
        return setCertificateUrlFromAPI();
    } 
} 
 
function createCertificate($siteName ="", $address1 ="", $address2 ="", $CP ="", $city ="", $email ="", $logo = "") {
    //On vérifie qu'on a bien un mail
    if (!$email) return array("apiKey" => false);

    //On urlencode
    $siteName = urlencode($siteName);
    $address1 = urlencode($address1);
    $address2 = urlencode($address2);
    $CP       = urlencode($CP);
    $city = urlencode($city);
    $email = urlencode($email);
    if (!$logo) $logo = "logo.jpg";
    $logo = urlencode($logo);
    $raison_sociale = $siteName;

    //On récupère l'url racine
    $url = (!empty($_SERVER['HTTPS']) ? 'https' : 'http') . '://' . $_SERVER['HTTP_HOST'];
    $logoUrl = $url . "/views/img/" . ltrim($logo, '/'); //On enleve le premier caractère de $logo si c'est un slash
    $url = $url . "/";
    $params = "cms=prestashop&email=$email&url=$url&address1=$address1&address2=$address2&CP=$CP&city=$city&logo_url=$logoUrl&raison_sociale=$raison_sociale";
    $datas = Tools::file_get_contents ("https://www.societe-des-avis-garantis.fr/wp-content/plugins/ag-core/api/createCertificate.php?" . $params);

    //Récupération dans un array php des données Json
    $datas = json_decode ( $datas, true);

    return $datas;
} 
