<?php
include("../functions.php");
function removeBOM($data) {
    if (0 === strpos(bin2hex($data), 'efbbbf')) {
       return Tools::substr($data, 3);
    } 
} 

//
//Déclaration de la fonction de récupération des avis
//

function import($url_ag, $apiKey, $productID, $idSAG, $from, $minDate, $maxDate, $maxResults, $token, $update) {

    //Préparation des paramètres à passer en variable
    $productID =  $productID ? '&productID='.$productID : '';                         //Filtre sur l'ID produit
    $idSAG =  $idSAG ? '&idSAG='.$idSAG : '';     //Filtre sur l'ID de l'avis
    $from =  $from ? '&from='.$from : '';                                             //Si from est à 1, $idSAG deviens le point de départ des avis à récupérer
    $minDate =  $minDate ? '&minDate='.$minDate : '';                                 //Filtre sur la date de l'avis
    $maxDate =  $maxDate ? '&maxDate='.$maxDate : '';                                 //Filtre sur la date de l'avis
    $maxResults = $maxResults ? '&maxR='.$maxResults : '';                             //Valeur de la clause sql LIMIT
    $token = $token ? '&token='.$token : '';                             //Valeur de la clause sql LIMIT
    $apiUrl= (string)$url_ag."wp-content/plugins/ag-core/api/reviews.php?apiPost=1" . $productID . $idSAG . $from . $minDate . $maxDate . $maxResults . $token;

    //
    //Connexion à l'API via cURL
    //
    $ch = curl_init();
    echo $apiUrl;
    $timeout = 5; // set to zero for no timeout
    curl_setopt ($ch, CURLOPT_URL, $apiUrl);
    curl_setopt($ch, CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_POSTFIELDS,
            "apiKey=".urlencode($apiKey));
    curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt ($ch, CURLOPT_CONNECTTIMEOUT, $timeout);
    $file_contents = curl_exec($ch);
    curl_close($ch);
    //
    //Exploitation des données récupérées
    //
    $file_contentsWithoutBom=removeBOM($file_contents);
    //si on peut enlever le bom on l'enlève
    if ($file_contentsWithoutBom) $file_contents=$file_contentsWithoutBom;

    $file_contents=json_decode($file_contents, true); //Décodage du contenu JSON récupéré

    //Si on a une erreur de decodage JSON
    if (json_last_error()) {
        var_dump(json_last_error());
        echo "erreur JSON?";
    } 

    //Pour chaque avis
    foreach ($file_contents as $val) {
        $updateAverage=0;    //Initialisation variable déterminant si on doit updater la moyenne des avis
        echo $val["review_status"];
        //on va vérifier qu'il n'existe pas dans la base de données
        $sql = 'SELECT * FROM '._DB_PREFIX_.'sag_reviews WHERE id_product_avisg='.(int)$val["idSAG"];

        //Si l'avis a le statut 0 (en attente) ou 2 (supprimé)
        if ($val["review_status"]==0 or $val["review_status"]==2) {
            //Et qu'il existe, il faut le supprimer
            if ($results = Db::getInstance()->ExecuteS($sql))
            {
                //Supprimer l'avis
                echo "Il faut supprimer cet avis";
                if (version_compare(_PS_VERSION_, '1.5', '<')) $table = _DB_PREFIX_ . 'sag_reviews';
                else $table = 'sag_reviews';
                //On delete la ligne dans la table
                Db::getInstance()->delete($table,'id_product_avisg='.(int)$val["idSAG"], 1);
                echo "Supprimé avec succès";
                $updateAverage=1;                                //On passe updateAverage à true pour updater les moyennes des avis
            } 
            else{
                echo "RAS"; //On a rien à faire, l'avis est soit déjà supprimé soit en attente
            } 
        } 
        //Sinon l'avis a le statut validé (1)
        else {
            //Si l'avis est déjà dans la base de données
            if ($results = Db::getInstance()->ExecuteS($sql))
            {
                //echo "<br>requete: $sql <br>";
                //var_dump($results);
                //Et que $update est à true, on update l'avis
                if ($update) {
                    echo "Enregistrement déjà présent, on update";
                    //Construction du nom
                    $lastName = ($val['lastname'] ? " " . Tools::strtoupper($val['lastname'][0]) . "." : "");
                    $reviewerName = pSQL(Tools::ucfirst($val["reviewer_name"]) . $lastName);
                    $datas = array(
                    'id_product_avisg' => (int)$val["idSAG"],
                    'product_id' => (int)$val["idProduct"],
                    'rate' => (int)$val["review_rating"],
                    'review' => pSQL($val["review_text"]),
                    'ag_reviewer_name' => $reviewerName,
                    'date_time'=> (int)strtotime($val["date_time"]),
                    'answer_text' => pSQL($val["answer_text"]),
                    'answer_date_time' => (int)strtotime($val["answer_date_time"]),
                    );

                    if (version_compare(_PS_VERSION_, '1.5', '<')) {
                        Db::getInstance()->autoExecute(_DB_PREFIX_.'sag_reviews', $datas, 'UPDATE', 'id_product_avisg='.(int)$val["idSAG"]);
                    } 
                    else {
                        Db::getInstance()->update('sag_reviews', $datas,'id_product_avisg='.(int)$val["idSAG"]);
                    } 
                    echo "Updaté avec succès";
                    $updateAverage=1;                                //On passe updateAverage à true pour updater les moyennes des avis
                } 
                //Sinon $update est à false et on passe à l'avis suivant
                else {
                        echo "Enregistrement déjà présent, on update pas et on passe à la suite";
                } 
            } 
            //Sinon l'enregistrement n'existe pas et on l'insert
            else {
                echo "Enregistrement non présent, il faut l'insérer";
                //Construction du nom à afficher
                $lastName = ($val['lastname'] ? " " . Tools::strtoupper($val['lastname'][0]) . "." : "");
                $reviewerName = pSQL(Tools::ucfirst($val["reviewer_name"]) . $lastName);
                $datas = array(
                    'id_product_avisg' => (int)$val["idSAG"],
                    'product_id' => (int)$val["idProduct"],
                    'rate' => (int)$val["review_rating"],
                    'review' => pSQL($val["review_text"]),
                    'ag_reviewer_name' => $reviewerName,
                    'date_time'=> (int)strtotime($val["date_time"]),
                    'answer_text' => pSQL($val["answer_text"]),
                    'answer_date_time' => (int)strtotime($val["answer_date_time"]),
                    );
                //Presta <1.5
                if (version_compare(_PS_VERSION_, '1.5', '<')) {
                    Db::getInstance()->autoExecute(_DB_PREFIX_.'sag_reviews', $datas, 'INSERT');
                    //$err = Db::getInstance()->getMsgError();
                    //var_dump ($err);
                } 
                else {
                    Db::getInstance()->insert('sag_reviews', $datas);
                } 
                echo "Ajouté avec succès";
                $updateAverage=1;                                //On passe updateAverage à true pour updater les moyennes des avis
            } 
        } 
 
        echo "idSAG" . $val["idSAG"] . "   ";
        echo "idProduct" . $val["idProduct"] . "   ";
        echo "Note" . $val["review_rating"] . "   ";
        echo "State" . $val["review_status"] . "   ";

        //Si on a fait une insertion, update, ou suppression, il faut updater la table des moyennes d'avis et la répartition des notes + pourcent
        if ($updateAverage) {
            //On récupère le nombre d'avis pour ce produit
            $sql = "SELECT count(*) FROM "._DB_PREFIX_."sag_reviews WHERE product_id='".(int)$val["idProduct"]."'";
            $nb= Db::getInstance()->getValue($sql);

            //On récupère la somme des notes pour ce produit
            $sql = "SELECT SUM(rate) FROM "._DB_PREFIX_."sag_reviews WHERE product_id='".(int)$val["idProduct"]."'";
            $somme_review= Db::getInstance()->getValue($sql);

            //On calcule la note moyenne
            if ($nb>0) $rate=round($somme_review/$nb, 2);
            else $rate=0;

            //On détermine le nombre d'avis inférieur ou égal à 1
            $sql = "SELECT count(*) FROM "._DB_PREFIX_."sag_reviews WHERE product_id='".(int)$val["idProduct"]."' and rate <= 1";
            $nb1= Db::getInstance()->getValue($sql);

            //On détermine le nombre d'avis à 2
            $sql = "SELECT count(*) FROM "._DB_PREFIX_."sag_reviews WHERE product_id='".(int)$val["idProduct"]."' and rate <= 2 and rate > 1";
            $nb2= Db::getInstance()->getValue($sql);

            //On détermine le nombre d'avis à 3
            $sql = "SELECT count(*) FROM "._DB_PREFIX_."sag_reviews WHERE product_id='".(int)$val["idProduct"]."' and rate <= 3 and rate > 2";
            $nb3= Db::getInstance()->getValue($sql);

            //On détermine le nombre d'avis à 4
            $sql = "SELECT count(*) FROM "._DB_PREFIX_."sag_reviews WHERE product_id='".(int)$val["idProduct"]."' and rate <= 4 and rate > 3";
            $nb4= Db::getInstance()->getValue($sql);

            //On détermine le nombre d'avis à 5
            $sql = "SELECT count(*) FROM "._DB_PREFIX_."sag_reviews WHERE product_id='".(int)$val["idProduct"]."' and rate <= 5 and rate > 4";
            $nb5= Db::getInstance()->getValue($sql);

            //On détermine le pourcentage à 1
            $percent1 = round($nb1/$nb,2) * 100;
            $percent2 = round($nb2/$nb,2) * 100;
            $percent3 = round($nb3/$nb,2) * 100;
            $percent4 = round($nb4/$nb,2) * 100;
            $percent5 = round($nb5/$nb,2) * 100;

            //On regarde si on a déjà une ligne de moyenne pour ce produit
            $sql = "SELECT * FROM "._DB_PREFIX_."sag_average_rating WHERE product_id='".(int)$val["idProduct"]."'";
            //Si on a des résultats, on update la ligne
            if ($results = Db::getInstance()->ExecuteS($sql)) {
                $datas = array(
                'id_product_avisg' => (int)$val["idSAG"],
                'product_id' => (int)$val["idProduct"],
                'rate' => pSQL($rate),
                'reviews_nb' => (int)$nb,
                'percent1' => pSQL($percent1),
                'percent2' => pSQL($percent2),
                'percent3' => pSQL($percent3),
                'percent4' => pSQL($percent4),
                'percent5' => pSQL($percent5),
                'nb1'       => (int)$nb1,
                'nb2'       => (int)$nb2,
                'nb3'       => (int)$nb3,
                'nb4'       => (int)$nb4,
                'nb5'       => (int)$nb5,
                'date_time_update'=> (int)strtotime($val["date_time"]),
                );

                if (version_compare(_PS_VERSION_, '1.5', '<')) {
                    Db::getInstance()->autoExecute(_DB_PREFIX_.'sag_average_rating', $datas, 'UPDATE', 'product_id='.(int)$val["idProduct"]);
                    //$err = Db::getInstance()->getMsgError();
                    //var_dump ($err);
                } 
                else {
                    //On update une ligne dans la table
                    Db::getInstance()->update('sag_average_rating', $datas, 'product_id='.(int)$val["idProduct"]);
                } 
                echo "Updaté avec succès";
            } 
            //Sinon on insert une nouvelle ligne
            else {
                $nb=1;
                $datas = array(
                    'id_product_avisg' => (int)$val["idSAG"],
                    'product_id' => (int)$val["idProduct"],
                    'rate' => pSQL($rate),
                    'reviews_nb' => (int)$nb,
                    'percent1' => pSQL($percent1),
                    'percent2' => pSQL($percent2),
                    'percent3' => pSQL($percent3),
                    'percent4' => pSQL($percent4),
                    'percent5' => pSQL($percent5),
                    'nb1'       => (int)$nb1,
                    'nb2'       => (int)$nb2,
                    'nb3'       => (int)$nb3,
                    'nb4'       => (int)$nb4,
                    'nb5'       => (int)$nb5,
                    'date_time_update'=> (int)strtotime($val["date_time"]),
                    );
                if (version_compare(_PS_VERSION_, '1.5', '<')) {
                    Db::getInstance()->autoExecute(_DB_PREFIX_.'sag_average_rating', $datas, 'INSERT');
                } 
                else {
                    Db::getInstance()->insert('sag_average_rating', $datas);
                } 
                echo "Ligne de moyenne créée avec succès";
            } 
 
        } 
    } 

} 

//Verify a token
function tokenCheck ($token) {
    $apiKey=Configuration::get('sag_apiKey');
    return Tools::file_get_contents ("https://www.societe-des-avis-garantis.fr/wp-content/plugins/ag-core/api/checkToken.php?token=" . $token . "&apiKey=" . $apiKey);
} 
 
//Securely connect and post data to API
function postData($data, $dest, $token) {
    $apiKey=Configuration::get('sag_apiKey');
    $url = 'https://www.societe-des-avis-garantis.fr/wp-content/plugins/ag-core/api/' . $dest ."?token=$token&apiKey=" . $apiKey;
    $dataString = base64_encode(json_encode($data));
    $ch = curl_init( $url);
    curl_setopt( $ch, CURLOPT_POST, 1);
    curl_setopt( $ch, CURLOPT_POSTFIELDS, array("data" => $dataString));
    curl_setopt( $ch, CURLOPT_FOLLOWLOCATION, 1);
    curl_setopt( $ch, CURLOPT_HEADER, 0);
    curl_setopt( $ch, CURLOPT_RETURNTRANSFER, 1);
    return curl_exec( $ch);
} 
 
//Récupération de l'ID boutique depuis l'apiKey
$apiKey=Configuration::get('sag_apiKey');
if (!(isset($apiKey))) {
    echo "Erreur, vous devez renseigner l'API Key dans la page de configuration du module";
} 
